Unit SWCFNB;

{$F+}

Interface


Uses CRT,
     DOS,
     SWCVaria;


Procedure ActivateFNB(Name: ST08;BSwitch8: Bool);



Implementation



Uses SWCSubPr;



Procedure Switch8Pixel;                       ForWard;
Procedure Switch9Pixel;                       ForWard;



Var
  {Fontdefinitionsvariablen}
  CountPixel8or9  : Word;
  CountChars      : Word;
  CountPixelLines : Word;
  NumberFirstChar : Word;



Procedure ActivateFNB(Name: ST08;BSwitch8: Bool);
Var
  Error  : Word;
  FNBOfs : Word;
  FNBSeg : Word;
  FNBSiz : Word;
  HandF  : Hand;
  MaxSiz : Word;
  Regs   : Regi;
  Word0  : Word;
  Word1  : Word;
  Word2  : Word;

Begin

  OFileF(HandF,PRGPATH+'\'+Name+'.FBN',FRead,001);
  If IOResult2=000 Then
  Begin
    CrsrOff;
    FNBNAME:=NAME;
    FNB25NAME:=NAME;
    FNBSeg:=GetBuf(4104,Word0,Word1);
    MemErrorOut('ActivateFNB',Word0,000);
    BlockRead(HandF,FNBSiz,002,CntrHROW0);
    BlockRead(HandF,CountPixel8Or9,008,CntrHROW0);
    BlockRead(HandF,Mem[FNBSeg:0],FNBSiz-008,CntrHROW0);
    OFileF(HandF,'',FClose,001);
    Regs.AX:=$1110;
    Regs.ES:=FNBSeg;
    Regs.BP:=$0000;
    Regs.BH:=CountPixelLines;
    Regs.BL:=000;
    Regs.CX:=CountChars;
    Regs.DX:=NumberFirstChar;
    WaitForVerticalRetrace;
    Intr($10,Regs);
    If BSwitch8 Then
    If CountPixel8Or9=008 Then Switch8Pixel
    Else Switch9Pixel;
    FreeBuf(FNBSeg,Word0);
    MemErrorOut('ActivateFNB',Word0,000);
    BooleanErr:=BF;
  End
  Else
  BooleanErr:=BT;

End;




Procedure SetCharWidth(Width: Byte);
Const
  EGAVGA_SEQUENCER  = $03C4;         { Sequencer Adre-/Datenport }

Var
  Regs0 : Regi;
  X     : Byte;

Begin

  With Regs0 Do
  Begin
    If Width=008 Then BX:=$0001      { BH = horiz. Ausrichtung }
    Else BX:=$0800;                  { BL = Wert fr Seq. Reg. }
    X:=Port[$03CC] And Not(004+008);
    If Width=009 Then X:=X Or 004;
    Port[$03C2]:=X;
    CLI;
    PortW[EGAVGA_SEQUENCER]:=$0100;
    PortW[EGAVGA_SEQUENCER]:=$01+BL ShL 008;
    PortW[EGAVGA_SEQUENCER]:=$0300;
    STI;
    AX:=$1000;
    BL:=$13;
    Intr($10,Regs0);
  End;

End;




Procedure Switch8Pixel;
Begin

  SetCharWidth(008);

End;




Procedure Switch9Pixel;
Begin

  SetCharWidth(009);

End;




END.
