Unit SWCVaria;

{$F+}

Interface


Uses DOS,
     CRT;


Type
  LDTp     = Record                    { DOS-Format-Parameter }
               Media    : Byte;        { Media-Byte }
               Cluster  : Byte;        { Anzahl Sektoren pro Cluster }
               FAT      : Byte;        { Anzahl Sektoren fr die FAT }
               RootSize : byte;        { Eintrge im Hauptverzeichnis }
             End;

Const
  BF       = False;
  BT       = True;
  BColBlack        = 000;
  BColBlue         = $10;
  BColGreen        = $20;
  BColCyan         = $30;
  BColRed          = $40;
  BColMagenta      = $50;
  BColBrown        = $60;
  BColLightGray    = $70;
  TColBlack        = 000;
  TColBlue         = 001;
  TColGreen        = 002;
  TColCyan         = 003;
  TColRed          = 004;
  TColMagenta      = 005;
  TColBrown        = 006;
  TColLightGray    = 007;
  TColDarkGray     = 008;
  TColLightBlue    = 009;
  TColLightGreen   = 010;
  TColLightCyan    = 011;
  TColLightRed     = 012;
  TColLightMagenta = 013;
  TColYellow       = 014;
  TColWhite        = 015;
  TColBlink        = 128;

Type
  DTim     = DateTime;
  FTyp     = (P,S,T);
  DTyp     = (DTNone,DT320,DT360,DT720,DT12,DT144,DT288);
  IntL     = LongInt;
  IntM     = Integer;
  IntS     = ShortInt;
  Poin     = Pointer;
  Regi     = Registers;
  SRec     = SearchRec;
  ST01     = String[001];
  ST02     = String[002];
  ST03     = String[003];
  ST04     = String[080]; {wegen mehreren Extensions in EStr}
  ST05     = String[005];
  ST06     = String[006];
  ST07     = String[007];
  ST08     = String[008];
  ST09     = String[009];
  ST10     = String[010];
  ST11     = String[011];
  ST12     = String[012];
  ST13     = String[013];
  ST14     = String[014];
  ST15     = String[015];
  ST16     = String[016];
  ST17     = String[017];
  ST18     = String[018];
  ST19     = String[019];
  ST20     = String[020];
  ST21     = String[020];
  ST22     = String[022];
  ST23     = String[023];
  ST25     = String[025];
  ST28     = String[028];
  ST30     = String[030];
  ST31     = String[030];
  ST32     = String[032];
  ST33     = String[033];
  ST34     = String[034];
  ST35     = String[035];
  ST40     = String[040];
  ST46     = String[046];
  ST60     = String[060];
  ST62     = String[062];
  ST67     = String[067];
  ST72     = String[072];
  ST79     = String[079];
  ST80     = String[080];
  ST82     = String[082];
  STA0     = String[160];
  STFF     = String[255];
  Bool     = Boolean;
  DdptType = Array[000..010] Of Byte;
  DirRec   = Record
               DName    : ST14;
               DReserv  : Word;
               DAttr    : Byte;
               DTime    : IntL;
               DSize    : IntL;
             End;
  Hand     = Byte;
  HexPrnM  = (HPAll,HPNone,HPRed);
  HlpMod   = (SYS,PRG);
  FOM      = (Rd,RdWr,RdWr2);
  MEMods   = (Moved,
              LeftPressed,
              LeftReleased,
              RightPressed,
              RightReleased);
  MGTyps   = (MGTGet,MGTMove);
  OMods    = (FAppend,
              FAssign,
              FChkT,   {Kann Textdatei bearbeitet werden ?}
                       {Wenn ja, dann zum Lesen ffen.    }
              FClose,
              FDeAssign,
              FErase,
              FNew,
              FRead,
              FReadWrite,
              FReadWrite2,
              FReName);
  OutM     = (OutMFAX,
              OutMPRN);
  RVec     = Record
               {16 Bytes pro Feld}
               Edge_X  : IntM;
               Edge_Y  : IntM;
               FMode   : Byte;
               LenTab  : Byte;
               OfsTab  : Word;
               RecOfs  : Word;
               X1Tab   : Word;
               X2Tab   : Word;
               YTab    : Word;
             End;
  PGXVR    = Record
               BooleanBuf      : Bool;
               BooleanFullLine : Bool;
               BooleanTablet   : Bool;
               FlagScrBuf      : Byte;
               NamLst          : ST08;
               IndexRecD       : IntL;
               IndexRecI       : IntL;
               PGXDPath        : ST79;
               PGXIPath        : ST79;
               PGXOMod         : OMods;
               BooleanMove     : Bool;
               BufSeg          : Word;
               BufSize         : Word;
               Center_H        : IntM;
               Center_V        : IntM;
               IndexField      : IntM;
               IndexPGX        : Word;
               MaxSizeStandard : IntL;
               MaxSizeOverFlow : IntL;
               MskNames        : ST08;
               PGXBFix         : Bool;
               PGXBlockA       : IntL;
               PGXBlockB       : IntL;
               PGXDHandle      : Hand;
               PGXIHandle      : Hand;
               PGXPressFS      : Word;
               PGXSave         : Bool;
               PosChr          : IntS;
               PosCur          : IntS;
               PosStr          : IntS;
               RecSeg          : Word;
               RecSize         : Word;
               RecSizeVor      : Word;
               ScreenFColor    : Byte;
               ScreenFMode     : Bool;
               ScreenHeight    : Word;
               ScreenMode      : Byte;
               ScreenOfs       : Word;
               ScreenSeg       : Word;
               ScreenWidth     : Word;
               ScreenYEnd      : Byte;
               ScreenBufHand   : Hand;
               PGXUpTo         : IntL;
               Width           : Byte;
               VecRec          : RVec;
               VecSeg          : Word;
             End;
  PRNMods  = (PrintAllData,
              PrintOnlyNotExist,
              PrintNothing);
  ProcsIO  = (PNBlockRead,
              PNBlockWrite,
              PNEOF_F,
              PNEOF_T,
              PNFilePos,
              PNFileSize,
              PNRead,
              PNReadLn,
              PNReadLnB,
              PNReadLnS,
              PNReadLnW,
              PNSeek,
              PNTruncate,
              PNWrite,
              PNWriteLn,
              PNWriteS);
  ProgMod  = (Server,
              Client,
              Dfue,
              NotKey,
              OnlyProg);
  PXXRec   = Record
               PXXPath  : ST79;
               PXXIndex : IntM;
             End;
  PXXState = (Opening,
              ReNaming,
              Closing);
  SAr2     = Record
               ASDir : Array[001..009] Of ST01;
               ASNum : Array[001..009] Of IntM;
             End;
  SArr     = Array[000..008] Of IntL;
  TAln     = (TAlignLeft,
              TAlignRight,
              TAlignCenter,
              TAlignBlock,
              TAlignNot);
  TypForm  = Array[000..999] Of Byte;
  TLen     = Array[000..999] Of IntS;
  VTyps    = (FVarF,FVarT);
  XMSFunc  = (A20GlobOff,
              A20GlobOn,
              A20LokOff,
              A20LokOn,
              AllocEMB,
              FreeEMB,
              FreeHMA,
              GetFree,
              GetHMA,
              GetVersion,
              MoveEMB);
  XMSRec   =  Record
                XMSLen  : IntL;
                HandleS : Word;
                OffsS   : IntL;
                HandleT : Word;
                OffsT   : IntL;
              End;

Const
  BIOSErrNotAllowedFuncNo = $01;
  BIOSErrAdrMarkNotFound  = $02;
  BIOSErrWriteProtected   = $03;
  BIOSErrSectrNotFound    = $04;
  BIOSErrDMAOverRun       = $08;
  BIOSErrDataOverRun      = $09;
  BIOSErrReadError        = $10;
  BIOSErrDiskControler    = $20;
  BIOSErrTrackNotFound    = $40;
  BIOSErrTimeOut          = $80;
  LOG320  : LDTp=(Media: $FF;Cluster : 002;FAT: 002;RootSize: $70);
  LOG360  : LDTp=(Media: $FD;Cluster : 002;FAT: 002;RootSize: $70);
  LOG720  : LDTp=(Media: $F9;Cluster : 002;FAT: 003;RootSize: $70);
  LOG12   : LDTp=(Media: $F9;Cluster : 001;FAT: 007;RootSize: $E0);
  LOG144  : LDTp=(Media: $F0;Cluster : 001;FAT: 009;RootSize: $E0);
  LOG288  : LDTp=(Media: $F0;Cluster : 001;FAT: 009;RootSize: $E0);
  DDPT1440: DdptType=($DF,$02,$25,$02,$12,$1B,$FF,$6C,$F6,$0F,$08);
  DDPT1200: DdptType=($DF,$02,$25,$02,$0F,$1B,$FF,$54,$F6,$0F,$08);
  DDPT720 : DdptType=($DF,$02,$25,$02,$09,$2A,$FF,$50,$F6,$0F,$08);
  DDPT360 : DdptType=($DF,$02,$25,$02,$09,$2A,$FF,$50,$F6,$0F,$08);
  {-- Vorgaben fr den BOOT-Sektor mit Ladeprogramm ---------------}
  BootMaske  : Array[000..101] Of Byte =
                   ( $EB, $35,                { 0000   JMP 0037        }
                     $90,                     { 0002   NOP             }
                     {-- Daten des BPB --------------------------------}
                     $37, $57, $41, $52, $45, $00, $00, $00,
                     $00, $00, $00, $01, $00, $00, $00, $00,
                     $00, $00, $00, $00, $00, $00, $00, $00,
                     $00, $00, $00, $00, $00, $00, $00, $00,
                     $00, $00, $00, $00, $00, $00, $00, $00,
                     $00, $00, $00, $00, $00, $00, $00, $00,
                     $00, $00, $00, $00,
                     {-- Eigentliches Ladeprogramm --------------------}
                     $FA,                     { 0037   CLI             }
                     $B8, $30, $00,           { 0038   MOV     AX,0030 }
                     $8E, $D0,                { 003B   MOV     SS,AX   }
                     $BC, $FC, $00,           { 003D   MOV     SP,00FC }
                     $FB,                     { 0040   STI             }
                     $0E,                     { 0041   PUSH    CS      }
                     $1F,                     { 0042   POP     DS      }
                     $BE, $66, $7C,           { 0043   MOV     SI,7C66 }
                     $B4, $0E,                { 0046   MOV     AH,0E   }
                     $FC,                     { 0048   CLD             }
                     $AC,                     { 0049   LODSB           }
                     $0A, $C0,                { 004A   OR      AL,AL   }
                     $74, $04,                { 004C   JZ      0052    }
                     $CD, $10,                { 004E   INT     10      }
                     $EB, $F7,                { 0050   JMP     0049    }
                     $B4, $01,                { 0052   MOV     AH,01   }
                     $CD, $16,                { 0054   INT     16      }
                     $74, $06,                { 0056   JZ      005E    }
                     $B4, $00,                { 0058   MOV     AH,00   }
                     $CD, $16,                { 005A   INT     16      }
                     $EB, $F4,                { 005C   JMP     0052    }
                     $B4, $00,                { 005E   MOV     AH,00   }
                     $CD, $16,                { 0060   INT     16      }
                     $33, $D2,                { 0062   XOR     DX,DX   }
                     $CD, $19 );              { 0064   INT     19      }
  BootMes : STFF=(#13#10'7Ware-Copy (C) 2002 Karl Lindfeld'+
            #13#10+#13#10+'Keine Systemdiskette!'+#13#10+
            'Bitte Diskette wechseln und danach eine Taste'+
            ' drcken ...'+#13#10);

  BOOLBLP           : Bool=BF;
  BooleanNoK        : Bool=BT;
  BooleanPGX        : Bool=BF;
  BOOLMASKFUNC      : Bool=BF;
  BOOLWAIT          : Bool=BT;

  ColorBlack        = 000;
  ColorBlue         = 001;
  ColorGreen        = 002;
  ColorLBlue        = 009;
  ColorLGreen       = 010;
  ColorLRed         = 012;
  ColorRed          = 004;
  CrypTab           : Array[000..255] Of byte=
                     (013,254,028,217,040,163,203,156,116,071, {000-009}
                      137,215,245,094,132,030,009,229,152,117, {010-019}
                      041,107,127,037,055,140,056,220,010,176, {020-029}
                      182,061,004,119,052,085,113,118,168,023, {030-039}
                      042,102,188,241,153,076,092,129,166,029, {040-049}
                      233,093,051,230,194,234,084,036,181,165, {050-059}
                      086,221,014,024,227,131,175,209,078,149, {060-069}
                      208,130,075,247,057,104,068,161,025,063, {070-079}
                      148,192,177,073,239,147,164,126,090,169, {080-089}
                      062,200,158,236,123,091,232,106,150,250, {090-099}
                      070,012,159,064,065,002,080,082,205,034, {100-109}
                      222,027,072,171,154,183,253,193,157,111, {110-119}
                      167,162,196,197,006,044,069,173,011,145, {120-129}
                      115,160,191,211,017,007,088,112,101,213, {130-139}
                      021,170,110,237,016,046,018,074,226,143, {140-149}
                      146,020,179,032,067,224,022,047,105,031, {150-159}
                      035,133,125,048,050,098,097,189,219,214, {160-169}
                      043,141,039,225,228,138,249,087,089,201, {170-179}
                      190,204,251,172,100,114,210,060,187,218, {180-189}
                      212,054,202,144,059,038,139,238,033,001, {190-199}
                      195,135,186,095,096,174,199,248,049,128, {200-209}
                      223,246,207,053,083,231,122,000,066,198, {210-219}
                      109,136,235,108,242,184,216,081,008,103, {220-229}
                      099,120,206,121,180,240,045,178,019,151, {230-239}
                      252,058,255,185,244,003,077,079,155,243, {240-249}
                      142,005,134,124,015,026);                {250-255}
  DataKB            : IntL=000;
  DataO             : Word=000;
  DataS             : Word=000;
  DayNams           : Array[000..006] Of ST02=
                      ('SO','MO','DI','MI','DO','FR','SA');
  DayNams2          : Array[000..006] Of ST10=
                      ('Sonntag   ','Montag    ','Dienstag  ','Mittwoch  ',
                       'Donnerstag','Freitag   ','Samstag   ');
  DayProMonth       : Array[000..011] Of Byte=
                      (031,028,031,030,031,030,031,031,030,031,030,031);
  FNBNm             : Array[000..009] Of ST08=
                      ('','','','','','','','','','');
  HexTab            : Array[000..015] Of Byte=
                      (048,049,050,051,052,053,054,055,
                       056,057,065,066,067,068,069,070);
  MaxHandlesF       = 059;
  MaxHandlesT       = 039;
  Scramble          : ST80='';
  ScrM              : Array[000..001,000..003] Of Byte=
                      ((001,001,080,025),(001,001,080,050));
  SHWC              = 009;
  SHOWPBO           : Array[000..SHWC] Of Bool=
                      (BF,BF,BF,BF,BF,BF,BF,BF,BF,BF);
  SHOWPEE           : Array[000..SHWC] Of Real=(0,0,0,0,0,0,0,0,0,0);
  SHOWPHA           : Array[000..SHWC] Of Byte=(255,255,255,255,255,
                                                255,255,255,255,255);
  SHOWPLP           : Array[000..SHWC] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  SHOWSUB           : Array[000..SHWC] Of IntL=(0,0,0,0,0,0,0,0,0,0);

  TempIOByte        : Byte=000;
  TempIOSeg         : Array[000..019] Of Word=(0,0,0,0,0,0,0,0,0,0,
                                               0,0,0,0,0,0,0,0,0,0);
  TempIOSize        : Array[000..019] Of Word=(0,0,0,0,0,0,0,0,0,0,
                                               0,0,0,0,0,0,0,0,0,0);
  TIMEH             : Array[000..019] Of Byte=(255,255,255,255,255,
                                               255,255,255,255,255,
                                               255,255,255,255,255,
                                               255,255,255,255,255);
  TIMECNTR          : Array[000..019] Of IntL=(0,0,0,0,0,0,0,0,0,0,
                                               0,0,0,0,0,0,0,0,0,0);
  TSSize            = 4096;


Var
  ACTUALSEG         : Word;
  ARRAYBL           : Word;
  ArrayPoint        : Array[000..003] Of Byte;
  ArrFHndF          : Array[000..MaxHandlesF] Of Word;
  ArrFHndT          : Array[000..MaxHandlesT] Of Word;
  ArrFVarF          : Array[000..MaxHandlesF] Of File;
  ArrFVarFTime      : Array[000..MaxHandlesF] Of IntL;
  ArrFVarT          : Array[000..MaxHandlesT] Of File;
  ArrFVarTSeg       : Array[000..MaxHandlesT] Of Word;
  ArrFVarTIdxHRead  : Array[000..MaxHandlesT] Of IntM;
  ArrFVarTIdxTRead  : Array[000..MaxHandlesT] Of Word;
  ArrFVarTTime      : Array[000..MaxHandlesF] Of IntL;

  BLKPAKSEG         : Word;

  BCom1             : Bool;

  {Fr WAIT}
  Boolean13         : Bool;
  Boolean13C        : Bool;
  Boolean32         : Bool;
  BooleanAltD       : Bool;
  BooleanAltDn      : Bool;
  BooleanAltE       : Bool;
  BooleanAltF       : Bool;
  BooleanAltF1      : Bool;
  BooleanAltI       : Bool;
  BooleanAltL       : Bool;
  BooleanAltLe      : Bool;
  BooleanAltO       : Bool;
  BooleanAltRi      : Bool;
  BooleanAltUp      : Bool;
  BooleanAltV       : Bool;
  BooleanAltZ       : Bool;
  BooleanBack       : Bool;
  BooleanBlockD     : Bool;
  BooleanBlockR     : Bool;
  BooleanCntrlA     : Bool;
  BooleanCntrlB     : Bool;
  BooleanCntrlC     : Bool;
  BooleanCntrlD     : Bool;
  BooleanCntrlE     : Bool;
  BooleanCntrlEnd   : Bool;
  BooleanCntrlK     : Bool;
  BooleanCntrlO     : Bool;
  BooleanCntrlP     : Bool;
  BooleanCntrlR     : Bool;
  BooleanCntrlS     : Bool;
  BooleanCntrlDn    : Bool;
  BooleanCntrlF3    : Bool;
  BooleanCntrlF4    : Bool;
  BooleanCntrlF5    : Bool;
  BooleanCntrlF7    : Bool;
  BooleanCntrlFA    : Bool;
  BooleanCntrlLe    : Bool;
  BooleanCntrlRi    : Bool;
  BooleanCntrlUp    : Bool;
  BooleanCntrlX     : Bool;
  BooleanCntrlY     : Bool;
  BooleanDel        : Bool;
  BooleanDn         : Bool;
  BooleanEnd        : Bool;
  BooleanEx         : Bool;
  BooleanF1         : Bool;
  BooleanF2         : Bool;
  BooleanF3         : Bool;
  BooleanF4         : Bool;
  BooleanF5         : Bool;
  BooleanF6         : Bool;
  BooleanF7         : Bool;
  BooleanF8         : Bool;
  BooleanF9         : Bool;
  BooleanFA         : Bool;
  BooleanHome       : Bool;
  BooleanIns        : Bool;
  BooleanKey        : Bool;
  BooleanPD         : Bool;
  BooleanPU         : Bool;
  BooleanTL         : Bool;
  BooleanTR         : Bool;
  BooleanUp         : Bool;
  BooleanLeft       : Bool;
  BooleanRig        : Bool;
  BooleanShiftF1    : Bool;
  BooleanShiftF4    : Bool;
  BooleanShiftIns   : Bool;
  BooleanShowList   : Bool;

  BooleanErr        : Bool;
  BooleanOpen       : Bool;

  Capacity          : IntL;
  Char0             : Char;
  Char1             : Char;
  CntrHROW0         : Word;

  DArray            : Array[$0000..$4FFF] Of Byte;
  DIRZURUECK        : ST79;

  EditorField       : STFF;
  EditorField2      : STFF;

  FNBSWITCH8ON2     : Array[000..009] Of Bool;

  HP0               : HexPrnM;

  InfoField         : Array[000..004] Of Byte;
  IOResult2         : Word;

  LASTINDEX         : Word;
  LDTyp0            : LDTp;         { logische Formatinformationen }

  MaxTrys           : Byte;
  MskPointer        : Poin;
  MskPOfs           : Word;
  MskPSeg           : Word;

  ODDPT             : Poin;
  OldExit           : Poin;
  OldInt1C          : Poin;
  OldInt90          : Poin;

  PRGHN             : ST08;
  PRGNAME           : ST79;
  PRGPATH           : ST79;
  Ptr0              : Poin;

  RegAH             : Byte;
  RegAL             : Byte;
  RegAX             : Word;
  RegBX             : Word;
  RegCH             : Byte;
  RegCL             : Byte;
  RegCX             : Word;
  RegDH             : Byte;
  RegDI             : Word;
  RegDL             : Byte;
  RegDX             : Word;
  RegES             : Word;
  RegFL             : Word;

  TESTSTR           : STFF;

  V24HPSeg          : Word;
  V24HPOfs          : Word;
  V24TPSeg          : Word;
  V24TPOfs          : Word;
  VALCODE           : Word;

Const
  FNB25NAME         : ST08=('ZBNFILM');
  FNB50NAME         : ST08=('PC8X8');
  FNBNAME           : ST08=('');
  FNBSWITCH8ON      : Bool=BF;

Var
  FNBPointer        : Poin;
  FNBSEG            : Word;

Const
  PGX               = 011;
  BooleanFullLine   : Array[000..PGX] of Bool=
                      (BF,BF,BF,BF,BF,BF,BF,BF,BF,BF,BF,BF);
  FlagScrBuf        : Array[000..PGX] of Byte=(255,255,255,255,255,255,
                                               255,255,255,255,255,255);
  NamLst            : Array[000..PGX] of ST08=
                      ('00--FREI','01--FREI','02--FREI','03--FREI',
                       '04--FREI','05--FREI','06--FREI','07--FREI',
                       '08--FREI','09--FREI','10--FREI','11--FREI');
  IndexRecD         : Array[000..PGX] of IntL=(0,0,0,0,0,0,0,0,0,0,0,0);
  IndexRecI         : Array[000..PGX] of IntL=(0,0,0,0,0,0,0,0,0,0,0,0);
  PGXDPath          : Array[000..PGX] of ST79=
                      ('','','','','','','','','','','','');
  PGXIPath          : Array[000..PGX] Of ST79=
                      ('','','','','','','','','','','','');

Var
  {GETVECTORS}
  PGXI              : Byte;
  PGXOMod           : Array[000..PGX] Of OMods;
  booleanmove       : array[000..PGX] Of Bool;
  bufseg            : array[000..PGX] Of Word;
  bufsize           : array[000..PGX] Of Word;
  center_h          : array[000..PGX] Of IntM;
  center_v          : array[000..PGX] Of IntM;
  IndexField        : Array[000..PGX] Of IntM;
  indexpgx          : array[000..PGX] Of Word;
  MskNames          : Array[000..PGX] Of ST08;
  PGXBFix           : Array[000..PGX] Of Bool;
  PGXDHandle        : Array[000..PGX] Of Hand;
  PGXIHandle        : Array[000..PGX] Of Hand;
  PGXPressFS        : Array[000..PGX] Of Word;
  PGXSave           : Array[000..PGX] Of Bool;
  PosChr            : Array[000..PGX] Of IntS;
  PosCur            : Array[000..PGX] Of IntS;
  PosStr            : Array[000..PGX] Of IntS;
  RecSel            : Array[000..PGX] Of Word;
  RecSize           : Array[000..PGX] Of IntL;
  RecSizeVor        : array[000..PGX] Of IntL;
  Screen_FColor     : array[000..PGX] Of Byte;
  Screen_FMode      : array[000..PGX] Of Bool;
  Screen_Height     : array[000..PGX] Of Word;
  Screen_Mode       : array[000..PGX] Of Byte;
  Screen_Ofs        : array[000..PGX] Of Word;
  Screen_Sel        : array[000..PGX] Of Word;
  Screen_Width      : array[000..PGX] Of Word;
  Screen_YEnd       : array[000..PGX] Of Byte;
  ScreenSeg         : array[000..PGX] Of Word;
  PGXUpTo           : array[000..PGX] Of IntL;
  Width             : array[000..PGX] Of Byte;
  VecRec            : Array[000..PGX] Of RVec;
  VecSel            : Array[000..PGX] Of Word;


Const
  Opt               = 019;
  OptCounter        : Byte=255;


Const
  LSN       = 019;
  BLSNNew   : Bool=BF;
  BLSNNOTW  : Bool=BF;
  FrX1      : Array[000..LSN] Of IntS=(-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
                                       -1,-1,-1,-1,-1,-1,-1,-1,-1,-1);
  FrX2      : Array[000..LSN] Of IntS=(-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
                                       -1,-1,-1,-1,-1,-1,-1,-1,-1,-1);
  FrY1      : Array[000..LSN] Of IntS=(-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
                                       -1,-1,-1,-1,-1,-1,-1,-1,-1,-1);
  FrY2      : Array[000..LSN] Of IntS=(-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
                                       -1,-1,-1,-1,-1,-1,-1,-1,-1,-1);
  LSNNam    : Array[000..LSN] Of ST08=('','','','','','','','','','',
                                         '','','','','','','','','','');
  SHWIDX    : Array[000..LSN] Of IntS=(-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
                                       -1,-1,-1,-1,-1,-1,-1,-1,-1,-1);

Var
  LSNI              : Byte;
  ALnLSN            : IntL;
  ALnLSN2           : IntL;
  CLIPLSNI          : Hand;
  STRLSN            : STFF;
  BlockA            : Array[000..LSN] Of IntL;
  BlockB            : Array[000..LSN] Of IntL;
  BLSNPage          : Array[000..LSN] Of Bool;
  BNoPRNCode        : Array[000..LSN] Of Bool;
  BoolClr           : Array[000..LSN] Of Bool;
  BoolFix           : Array[000..LSN] Of Bool;
  BoolWrite         : Array[000..LSN] Of Bool;
  CntFields         : Array[000..LSN] Of Word;
  ColName           : Array[000..LSN] Of ST08;
  ColSeg            : Array[000..LSN] Of Word;
  CrsrX             : Array[000..LSN] Of IntS;
  CrsrY             : Array[000..LSN] Of IntS;
  Field             : Array[000..LSN] Of Word;
  FieldPos          : Array[000..LSN] Of Word;
  FileX             : Array[000..LSN] Of IntL;
  FileY             : Array[000..LSN] Of IntL;
  FPath             : Array[000..LSN] Of ST79;
  FrCntr            : Array[000..LSN] Of IntS;
  LastLine          : Array[000..LSN] Of IntL;
  LineSeg           : Array[000..LSN] Of Word;
  LineSize          : Array[000..LSN] Of Word;
  LisSiz            : Array[000..LSN] Of IntL;
  LSNHandle         : Array[000..LSN] Of Hand;
  ScreenMode        : Array[000..LSN] Of Bool;
  TitSeg            : Array[000..LSN] Of Word;


Const
  CDir              = 009;
  BoolAsk           : Array[000..CDir] Of Bool=
                      (BF,BF,BF,BF,BF,BF,BF,BF,BF,BF);
  DH00              : Hand=255;
  DH01              : Hand=255;
  DI2Lx             : Array[000..001] Of IntL=(000,000);
  DI2Px             : Byte=000;
  DirEA             : Array[000..CDir] Of IntL=
                      (-1,-1,-1,-1,-1,-1,-1,-1,-1,-1);
  DirNScrLen        : Byte=015;
  DirName           : Array[000..CDir] Of ST08=
                      ('','','','','','','','','','');
  DirXMSH           : Array[000..CDir] Of Hand=
                      (255,255,255,255,255,255,255,255,225,255);
  DirSel3           : Array[000..CDir] Of Word=
                      (000,000,000,000,000,000,000,000,000,000);
  DirSel2           : Array[000..CDir] Of Word=
                      (000,000,000,000,000,000,000,000,000,000);
  IndexLine         : IntL=(000);
  PLine             : Array[000..001] Of Byte=(000,000);

Var
  AktDir            : Byte;
  BoolMainRoot      : Bool;
  DirHandle         : Array[000..CDir] Of Hand;
  DirInfo           : SRec;
  DirPath           : Array[000..CDir] Of ST67;
  DirSeg2           : Array[000..CDir] Of Word;
  DIRUPTO           : IntL;
  DirVec            : Array[000..CDir] Of DirRec;
  FILEFROM          : IntL;
  FileName          : ST79;
  IndexPage         : IntL;

Const
  XMS               = 197;
  XMSLA             : IntL=000;
  XMSBISXMSDRV      : Bool=BF;
  XMSBPGXVEC        : Bool=BF;
  XMSERROR          : Byte=$80;
  XMSFREELONG       : IntL=000;

Var
  XMSADRESS         : Poin;
  XMSBOOLS          : Array[000..XMS] Of Bool;
  XMSBFAK           : Real;
  XMSFREESTR        : ST12;
  XMSHANDLE         : Word;
  XMSHANDLES        : Array[000..XMS] Of Byte;
  XMSMOVSTRUC       : XMSRec;
  XMSNAMES          : Array[000..XMS] Of ST12;
  XMSOFFSETS        : Array[000..XMS] Of IntL;
  XMSMINSIZE        : IntL;
  XMSMyBlock        : IntL;
  XMSOFS            : Word;
  XMSSEG            : Word;
  XMSREGAX          : Word;
  XMSREGBX          : Word;
  XMSREGBP          : Word;
  XMSREGCX          : Word;
  XMSREGDI          : Word;
  XMSREGDS          : Word;
  XMSREGDX          : Word;
  XMSREGES          : Word;
  XMSREGFL          : Word;
  XMSREGSI          : Word;
  XMSREGSP          : Word;
  XMSREGSS          : Word;
  XMSSIZES          : Array[000..XMS] Of IntL;
  XMSSegOfs         : Array[000..001] Of Word;
  XMSTEXT           : Text;
  XMSH0             : Hand;



Implementation



END.
